// -*- c++ -*-
/*
 *  USBSink - dirtransfer.h
 *
 *  Copyright (C) 2006-2007 Marko Anastasov
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __DIR_TRANSFER_H__
#define __DIR_TRANSFER_H__

#include "datatransfer.h"

#include <list>

#include <glibmm/ustring.h>

namespace USBSink
{

namespace Transfer
{

class DirTransfer : public DataTransfer
{
 public:

  DirTransfer(const Glib::ustring& root_src_path,
              const Glib::ustring& root_dest_path);
  ~DirTransfer();

  void add_file(const Glib::ustring& path);
  virtual void run(Logger* logger,
                   TaskHandling::Task* task,
                   GnomeVFSAsyncXferProgressCallback callback);

  Glib::ustring build_destination_path(const Glib::ustring& source_file);

 private:

  Glib::ustring root_src_path_;
  Glib::ustring root_dest_path_;
  std::list<Glib::ustring> src_files_;

  GnomeVFSAsyncHandle* async_handle_;
};

} // namespace Transfer

} // namespace USBSink

#endif // __DIR_TRANSFER_H__
