// -*- c++ -*-
/*
 *  USBSink - filelistloader.h
 *
 *  Copyright (C) 2006 Marko Anastasov
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _FILE_LIST_LOADER_H_
#define _FILE_LIST_LOADER_H_

#include <list>
#include <tr1/memory>

#include "clientdispatcher.h"

#include <gtkmm/textbuffer.h>

namespace USBSink
{

namespace TaskHandling
{

class Item;

typedef std::tr1::shared_ptr<Item> SharedItem;

class FileListLoader
{
 public:

  static void get_items(const Glib::RefPtr<Gtk::TextBuffer>& buffer,
                        std::list<SharedItem>& ret_items);

  static void get_items(const Glib::RefPtr<Gtk::TextBuffer>& buffer,
                        const ClientSlot& slot,
                        std::list<SharedItem>& ret_items);

 private:
  
  static void get_items_private(const Glib::RefPtr<Gtk::TextBuffer>& buffer,
                                ClientSlot* slot,
                                std::list<SharedItem>& items);
};

} // namespace TaskHandling

} // namespace USBSink

#endif // _FILE_LIST_LOADER_H_
