// -*- c++ -*-
/*
 *  USBSink - taskitem.h
 *
 *  Copyright (C) 2006 Marko Anastasov
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _TASK_ITEM_H_
#define _TASK_ITEM_H_

#include <list>
#include <vector>

#include <glibmm/ustring.h>

namespace USBSink
{

namespace TaskHandling
{

/**
 * Interface representing an item in a task's white or black file list.
 */
class Item
{
 public:
  Item() {}
  virtual ~Item() {}

  virtual Glib::ustring get_name() const = 0;

  virtual Glib::ustring get_name_formatted() const = 0;

  virtual std::vector<Glib::ustring> get_text_for_display() const = 0;

  virtual void set_name(const Glib::ustring& new_name) = 0;

  virtual bool match(const Glib::ustring& str) const = 0;
};

} // namespace TaskHandling

} // namespace USBSink

#endif // _TASK_ITEM_H_
